<template>
  <div :class="['card', !grow && 'card_no-grow']">
    <div class="card__header">
      <template v-if="!$slots.header">
        <div class="card__title">{{ title }}</div>
        <slot name="after-title" />
      </template>
      <slot name="header" />
    </div>
    <div class="card__content">
      <slot />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

export default defineComponent({
  name: 'card',
  props: {
    title: { type: String, default: '' },
    grow: { type: Boolean, default: true },
  },
});
</script>

<style lang="scss" scoped>
.card {
  flex: 1 1 auto;
  padding: 0.5rem;
  background: #f8f9fa;
  color: #495057;
  border: 1px solid #dee2e6;
  border-radius: 3px;
  display: flex;
  flex-direction: column;

  &:not(:last-child) {
    margin-bottom: 2.25rem;
  }

  &_no-grow {
    flex: none;
  }

  &__title-wrapper {
    width: 100%
  }

  &__title {
    margin-right: 2rem;
    font-size: 2rem;
    font-weight: 500;
    white-space: nowrap;
  }

  &__header {
    display: flex;
    align-items: center;
    justify-content: space-between;
    flex-wrap: wrap;
    padding: 1.5rem 1.5rem 0;
  }

  &__content {
    flex: 1;
    min-height: 0;
    display: flex;
    flex-direction: column;
    padding: 2.5rem;
  }
}
</style>
